VERSION 5.00
Begin VB.Form frmServer 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Server"
   ClientHeight    =   6585
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8910
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6585
   ScaleWidth      =   8910
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtPort 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   420
      Left            =   7800
      TabIndex        =   5
      Text            =   "5123"
      Top             =   6060
      Width           =   975
   End
   Begin VB.ComboBox cboConfiguration 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   5280
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   120
      Width           =   3495
   End
   Begin PTSTctrl.PTSTengine hl7Engine 
      Left            =   2280
      Top             =   2280
      _ExtentX        =   1085
      _ExtentY        =   873
      StrictGrammar   =   0   'False
      MappingFile     =   ""
   End
   Begin CHMllpServerControl.CHMllpServer svrLlpServer 
      Left            =   4320
      Top             =   2280
      _ExtentX        =   635
      _ExtentY        =   635
   End
   Begin VB.CommandButton cmdStartStop 
      Caption         =   "&Start Listening"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   6000
      Width           =   2055
   End
   Begin VB.TextBox txtOutput 
      Height          =   5295
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   600
      Width           =   8655
   End
   Begin VB.Label lblPort 
      Caption         =   "Port:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   7200
      TabIndex        =   4
      Top             =   6120
      Width           =   495
   End
   Begin VB.Label lblConfiguration 
      Caption         =   "Configuration:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   3600
      TabIndex        =   3
      Top             =   143
      Width           =   1575
   End
End
Attribute VB_Name = "frmServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' This application is a simple example of using the Chameleon generated objects.  It
' is intended to be a helpful starting point in understanding how to use these objects
' but must be fleshed out in the following areas to provide a full solution for an
' application HL7 interface:
' 1) You will need to work out how your application will handle logging of messages
'    and data, in particular how bad transactions should be logged.
' 2) The code will need to be modified to insert the parsed data into a database whether
'    by using explicit database calls or going through some type of middle tier layer that
'    your application may support.
' 3) Some customers choose to deploy HL7 interfaces as Windows Services.  This can be done
'    easily with Chameleon.  One thing to keep in mind though is that the networking components
'    supplied with Chameleon require a Windows 'message loop'.  Often times Windows Services do
'    not have a message loop - but one can be easily set up by invoking RunMessageLoop on
'    the networking component supplied with Chameleon.  See the manual for running Chameleon
'    within services.
' 4) Definitely take the time to read the manual and go through the tutorials after looking
'    at this example before attempting to deploy a production solution.  We do provide custom
'    onsite training and technical implementation services if you require them.
'
' If you are looking for a much more complete 'out of the box' solution for your HL7 needs it would be
' a good idea to evaluate Iguana - Iguana is powered by Chameleon but
' provides a complete runtime web based infrastructure for your HL7 interfaces.
' So it provides advanced logging and monitoring capability for you
' which makes it a very attractive option for many customers.

' According to MSDN, the limit for the text box size is 32K
Const MAX_SIZE_TEXT_BOX As Long = 30000

Dim vmeAckEngine As New VMengine
Dim vmeNackEngine As New VMengine

' This code is only for demonstration purposes.  Memo controls can only take a certain amount
' of data - 32k at the time this example was written.  As a result we check the length of
' the memo control and truncate it if it reaches this limit.
'
' A real HL7 interface should have some type of system of logging into log files.  Iguana for
' instance has a very nice logging system that allows administrators to drill into and browse
' processed messages and errors.  How you implement this logging is up to your requirements
' for run time management of your HL7 interface.
Private Sub DisplayOutput(ByVal Message As String)
   If Len(txtOutput.Text) > MAX_SIZE_TEXT_BOX Then
      txtOutput.Text = Right(txtOutput.Text, (MAX_SIZE_TEXT_BOX / 2)) & Message & vbNewLine
   Else
      txtOutput.Text = txtOutput.Text & Message & vbNewLine
   End If
   ' The following is to ensure that the text box scrolls to the last character
   txtOutput.SelStart = Len(txtOutput.Text)
   txtOutput.SelLength = 0
End Sub

Private Sub DisplaySeparator()
   DisplayOutput "-----"
End Sub

' For demonstration purposes, all runtime errors will be displayed in the output text box
Private Sub HandleError(ByVal Context As String, ByVal Description As String)
   DisplayOutput Context
   DisplayOutput svrLlpServer.MakeMessagePrintable(Description, vbNewLine, MAX_SIZE_TEXT_BOX)
   DisplaySeparator
   Err.Clear
End Sub

Private Sub Form_Load()
On Error GoTo ErrorHandler:
   Dim ConfigIndex As Long

   ' The first step in making the generated HL7engine component useable is to load
   ' the message definition or 'vmd' file.  This file contains all the definitions
   ' for the messages, how they are identified and how they should be mapped into the
   ' generated data objects based on the tables that you define in the Chameleon GUI.

   ' HL7engine is a generated engine which means that it has an interface based
   ' on the Messages and Tables you define in your vmd file.  The use of stub code is
   ' helpful since it means that the compiler can catch typos or spelling mistakes of fields at compile
   ' rather than run time.  However it is not the only way you can use Chameleon.  It is
   ' possible to use a non-stubcode interface to the Chameleon parsing engine which we call
   ' the 'dynamic interface'.  Please review the manual documentation for more details if you
   ' need this functionality - most customers find that the stub code interface works well for
   ' their applications.
   DisplayOutput "Loading vmd files..."
   hl7Engine.Load App.Path & "\test_data.vmd"
   DisplayOutput "test_data.vmd loaded"
   
   ' This example has two other Chameleon HL7 engines to help with the generation of
   ' HL7 ACKnowledgement and Negative ACKnowledgment messages.  In this case each engine
   ' object is not a stubcode generated engine but is a dynamic engine.  For more information
   ' please read the Chameleon manual about auto-acknowledgement.
   vmeAckEngine.Load App.Path & "\autoack.vmd"
   DisplayOutput "autoack.vmd loaded"
   vmeNackEngine.Load App.Path & "\autonack.vmd"
   DisplayOutput "autonack.vmd loaded"
   
   DisplaySeparator
   
   ' Setting up the combo box is just part of mechanics of this example which
   ' is for teaching purposes only.  A real HL7 client would most likely be part
   ' of a backend service.
   For ConfigIndex = 0 To (hl7Engine.InternalEngine.CountOfConfig - 1)
      cboConfiguration.AddItem hl7Engine.InternalEngine.ConfigName(ConfigIndex)
   Next ConfigIndex
   cboConfiguration.ListIndex = hl7Engine.InternalEngine.CurrentConfigIndex
   
   Exit Sub
ErrorHandler:
   HandleError "Error while loading form:", Err.Description
End Sub

Private Sub cboConfiguration_Click()
   hl7Engine.InternalEngine.CurrentConfigIndex = cboConfiguration.ListIndex
End Sub

' This code is just part of the mechanics of this example.
Private Sub cmdStartStop_Click()
On Error GoTo ErrorHandler:
   Dim strAction As String

   If svrLlpServer.IsListening = False Then
      strAction = "starting"
      svrLlpServer.StartListen Val(txtPort.Text)
      DisplayOutput "Started listening on port " & svrLlpServer.Port
      cmdStartStop.Caption = "&Stop Listening"
      txtPort.Enabled = False
   Else
      strAction = "stopping"
      ' This will stop us from accepting new connections
      svrLlpServer.StopListen
      ' This will disconnect all existing connections.
      svrLlpServer.DisconnectAllClients
      DisplayOutput "Stopped listening on port " & svrLlpServer.Port
      cmdStartStop.Caption = "&Start Listening"
      txtPort.Enabled = True
   End If
   
   DisplaySeparator
   
   Exit Sub
ErrorHandler:
   HandleError "Error while " & strAction & " server:", Err.Description
End Sub

' This is the first event we would expect to get from a client connecting to us.  Notice
' that all the networking events have a 'Client' object that can be used to interact with
' the peer machine that is sending HL7 data.
Private Sub svrLlpServer_ClientConnected(Client As CHMllpServerControl.CHMllpConnection)
   DisplayOutput "Client connected from " & Client.RemoteIpAddressAsString
   DisplaySeparator
End Sub

' This event is fired if we have an error on a given TCP/IP connection.  When you
' develop a real application you should log this information for troubleshooting purposes.
Private Sub svrLlpServer_ClientErrorReceived(Client As CHMllpServerControl.CHMllpConnection, ByVal ErrorMessage As String, ByVal ErrorCode As Long)
   HandleError "Client error from " & Client.RemoteIpAddressAsString & ":", ErrorMessage
End Sub

' This event is fired if we have an error related to the listening socket itself rather
' than a specific connection.  In practice this event is rarely invoked.
Private Sub svrLlpServer_ErrorReceived(ByVal ErrorMessage As String, ByVal Code As Long)
   HandleError "Server error:", ErrorMessage
End Sub

' HL7 data is sent via the Lower Layer Protocol.  Read the manual for more detailed background
' on this protocol.  If you have a badly behaved counter party it is possible they may send data
' that is outside of the LLP start of block and end of block characters - this event will tell
' you when this problem occurs.
Private Sub svrLlpServer_DataIgnored(Client As CHMllpServerControl.CHMllpConnection, ByVal Data As String)
   DisplayOutput "Ignored data outside of LLP connection from client " & Client.RemoteIpAddress & ":"
   DisplayOutput Data
   DisplaySeparator
End Sub

' This event is the main entry point for where we get an actual HL7 message off
' 'the wire' from a connected peer.  Notice that we 'manually' invoke the
' ParseMessage method on the HL7Engine object.  This will
' fire one of the generated onMessage events which follow
' after this method or the ParseError method.
'
' The LLP TCP/IP transport components are not tightly coupled to the
' HL7Engine object.  You can use any kind of transport you like with Chameleon, including
' your own transports or third party components.
'
' In this application we do not block on events - this is because the
' networking components are asynchronous.  You can write synchronous applications using
' Chameleon but you would need to use another transport mechanism other than the LLP TCP/IP
' components supplied here.
Private Sub svrLlpServer_MessageReceived(Client As CHMllpServerControl.CHMllpConnection, ByVal Message As String)
On Error GoTo ErrorHandler:
   Dim ResponseMessage As String

   ' All our networking events from llpServer have a Client object which gives us
   ' information about the host we received a message from.
   DisplayOutput "Received message from " & Client.RemoteIpAddressAsString & ":"
   
   ' We use the MakeMessagePrintable function to 'pretty print'
   ' the HL7 message into a format that can be easily read in
   ' the log files.  This function converts \r characters into the
   ' string given in the second argument of MakeMessagePrintable.
   '    i.e. in this case a \r\n sequence which displays nicely in the memo control.
   ' The third argument is the maximum length of the message before
   ' we truncate it.  This is done because displaying data within a memo
   ' control is actually very slow - so displaying a message of 100k in
   ' the memo control window can give the appearance of hanging the server.
   ' (i.e. a long blocking event)
   DisplayOutput svrLlpServer.MakeMessagePrintable(Message, vbNewLine, MAX_SIZE_TEXT_BOX)
   
   ' We parse the message with Chameleon using the Parse procdure
   hl7Engine.Parse Message
   
   ' The following two sub-procedures provide modular error handling so that an
   ' error in each sub-procedure will not appear in this top-level procedure.
   
   ' Generate an ACK using the auto-acknowledgement engine
   ResponseMessage = GenerateResponseMessage(vmeAckEngine, Message)
   
   TransmitMessage Client, ResponseMessage
   Exit Sub
ErrorHandler:
   HandleError "Error while parsing message:", Err.Description
   
   ' The following two sub-procedures provide modular error handling so that an
   ' error in each sub-procedure will not appear in this top-level procedure.
   
   ' Parse error occurred so we generate a NACK using the NackEngine
   ResponseMessage = GenerateResponseMessage(vmeNackEngine, Message)
   
   TransmitMessage Client, ResponseMessage
End Sub

' The next set of events are triggered for each of messages that has been
' defined in the message definition file.  In each case there is a generated
' Msg object.  This object has tables and sub tables with properties that you
' can access to obtain the data that has been parsed out of each message.
'
' It must be emphasized that this will be a mirror of the 'table grammar' for
' each message - i.e. the user defined definitions of each table and the fields
' in those tables as defined in the Chameleon GUI.
' Begin on message events (comment used as an anchor by STVB6)
Private Sub hl7Engine_OnMessageADTA04(Message As PTSTMsgADTA04, ResultMessage As String)
   DisplayOutput "Parsed ADTA04 message."
   DisplayOutput "SetIDPid: " &  Str(Message.InfoTbl(1).SetIDPid)
   DisplayOutput "PatientNameFamilyNameSurnamerepeatsonlyfirstinstancemapped: " &  Message.InfoTbl(1).PatientNameFamilyNameSurnamerepeatsonlyfirstinstancemapped
   DisplayOutput "PatientNameGivenNamerepeatsonlyfirstinstancemapped: " &  Message.InfoTbl(1).PatientNameGivenNamerepeatsonlyfirstinstancemapped
   DisplayOutput "DatetimeOfBirthTime: " &  Format(Message.InfoTbl(1).DatetimeOfBirthTime)
   DisplayOutput "AdministrativeSex: " &  Message.InfoTbl(1).AdministrativeSex
   DisplaySeparator
End Sub
' End on message events (comment used as an anchor by STVB6)

Private Function GenerateResponseMessage(ByRef ResponseEngine As VMengine, ByVal ReceivedMessage As String) As String
On Error GoTo ErrorHandler:
   GenerateResponseMessage = ResponseEngine.GenerateAck(ReceivedMessage)
   Exit Function
ErrorHandler:
   ' The response engine failed to parse the message, so we generate a hard-coded NACK message.
   ' This should only really happen when there is real garbage.
   HandleError "Error while generating response message:", Err.Description
   GenerateResponseMessage = "MSH|^~\&|ACME|ACME_APP|XYZ|XYZ_APP|||NACK|XXX|P|2.4|" & vbCr & "MSA|AA|XXX|" & vbCr
End Function

Private Sub TransmitMessage(Client As CHMllpServerControl.CHMllpConnection, ByVal Message As String)
On Error GoTo ErrorHandler:
   ' We send the response ACK or NACK message to the client via the TransmitMessage procedure
   Client.TransmitMessage Message
   Exit Sub
ErrorHandler:
   HandleError "Error while sending response message to client " & Client.RemoteIpAddressAsString & ":", Err.Description
End Sub

' This is the event we would expect when a client disconnects.  Note that sometimes
' if the client is not well behaved we may not receive this event.
Private Sub svrLlpServer_ClientDisconnected(Client As CHMllpServerControl.CHMllpConnection)
   DisplayOutput "Client disconnected from " & Client.RemoteIpAddressAsString
   DisplaySeparator
End Sub

Private Sub Form_Unload(Cancel As Integer)
On Error GoTo ErrorHandler:
   ' This will stop us from accepting new connections
   svrLlpServer.StopListen
   ' This will disconnect all existing connections
   svrLlpServer.DisconnectAllClients
   Exit Sub
ErrorHandler:
   HandleError "Error while unloading form:", Err.Description
End Sub
